'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _DesktopComponent = require('../DesktopComponent');

var _DesktopComponent2 = _interopRequireDefault(_DesktopComponent);

var _Color = require('../Color');

var styles = {
  button: {
    userSelect: 'none',
    cursor: 'default',
    backgroundColor: '#cccccc',
    outline: 'none',
    borderWidth: '2px',
    borderStyle: 'solid',
    borderColor: '#cccccc',
    paddingTop: 0,
    paddingBottom: 0,
    paddingLeft: '32px',
    paddingRight: '32px',
    lineHeight: '28px',
    fontFamily: '"Segoe UI", Frutiger, "Frutiger Linotype", "Dejavu Sans", "Helvetica Neue", Arial, sans-serif',
    fontSize: '15px',
    color: '#000000',

    ':hover': {
      color: '#000000',
      borderColor: '#7a7a7a'
    },

    ':active': {
      color: '#000000',
      borderColor: '#999999',
      backgroundColor: '#999999'
    }
  },

  colorButton: {
    color: '#ffffff',
    borderColor: '#0078d7',
    backgroundColor: '#0078d7',

    ':hover': {
      borderColor: '#004e8c'
    },

    ':active': {
      borderColor: '#004e8c',
      backgroundColor: '#004e8c'
    }
  },

  pushTransform: {
    transform: 'scale(0.97)',
    transition: 'transform .1s ease-in'
  }
};

var Button = (function (_Component) {
  _inherits(Button, _Component);

  function Button() {
    _classCallCheck(this, _Button);

    _get(Object.getPrototypeOf(_Button.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Button, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if ((0, _reactDom.findDOMNode)(this).previousSibling) {
        this.applySiblingStyle();
      }
    }
  }, {
    key: 'applySiblingStyle',
    value: function applySiblingStyle() {
      if (!this.refs.element.style.marginLeft) {
        this.refs.element.style.marginLeft = '12px';
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var children = _props.children;
      var color = _props.color;
      var onPress = _props.onPress;
      var push = _props.push;

      var props = _objectWithoutProperties(_props, ['style', 'children', 'color', 'onPress', 'push']);

      var componentStyle = _extends({}, styles.button, style);
      switch (color) {
        case true:
          styles.colorButton = _extends({}, styles.colorButton, {
            borderColor: this.state.color,
            backgroundColor: this.state.color,
            ':hover': _extends({}, styles.colorButton[':hover'], {
              borderColor: (0, _Color.darkenColor)(this.state.color, .35)
            }),

            ':active': _extends({}, styles.colorButton[':active'], {
              borderColor: (0, _Color.darkenColor)(this.state.color, .35),
              backgroundColor: (0, _Color.darkenColor)(this.state.color, .35)
            })
          });

          componentStyle = _extends({}, componentStyle, styles.colorButton);
          break;
        case 'blue':
          componentStyle = _extends({}, componentStyle, styles.colorButton);
          break;
      }

      var type = 'button';
      if (this.props.onPress === 'submit') {
        type = 'submit';
        onPress = null;
      } else {
        onPress = this.props.onClick ? this.props.onClick : this.props.onPress;
      }

      componentStyle = _extends({}, componentStyle, {
        visibility: this.state.visible ? 'visible' : 'hidden',
        display: this.state.display ? 'block' : 'none'
      });

      if (push) {
        componentStyle[':active'] = _extends({}, componentStyle[':active'], styles.pushTransform);
      }

      return _react2['default'].createElement(
        'button',
        _extends({
          ref: 'element',
          type: type,
          onClick: onPress,
          style: componentStyle
        }, props),
        children
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      color: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.bool]),
      push: _react.PropTypes.bool,
      onClick: _react.PropTypes.func,
      onPress: _react.PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.func])
    },
    enumerable: true
  }]);

  var _Button = Button;
  Button = (0, _DesktopComponent2['default'])(Button) || Button;
  return Button;
})(_react.Component);

exports['default'] = Button;
module.exports = exports['default'];