'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DesktopComponent = require('../DesktopComponent');

var _DesktopComponent2 = _interopRequireDefault(_DesktopComponent);

var _radium = require('radium');

var styles = {
  checkbox: {
    WebkitUserSelect: 'none',
    WebkitAppearance: 'none',
    borderWidth: '2px',
    borderStyle: 'solid',
    borderColor: 'rgba(0, 0, 0, .8)',
    padding: '8px',
    color: '#fff',
    verticalAlign: 'bottom',
    marginRight: '9px',

    ':focus': {
      outline: 'none'
    }
  },

  checkboxDark: {
    borderColor: 'rgba(255, 255, 255, .82)'
  },

  'checkbox:active': {
    borderColor: 'rgba(0, 0, 0, 0)',
    backgroundColor: 'rgba(0, 0, 0, .57)'
  },

  'checkbox:hover': {
    borderColor: 'rgba(0, 0, 0, 1)'
  },

  'checkbox:checked': {
    backgroundColor: '#007CD1',
    borderColor: '#007CD1'
  },

  'checkboxDark:active': {
    borderColor: 'rgba(255, 255, 255, 0)',
    backgroundColor: 'rgba(255, 255, 255, .63)'
  },

  'checkboxDark:hover': {
    borderColor: 'rgba(255, 255, 255, 1)'
  },

  'checkboxDark:checked': {
    backgroundColor: '#007CD1',
    borderColor: '#007CD1'
  },

  label: {
    fontFamily: '"Segoe UI", Frutiger, "Frutiger Linotype", "Dejavu Sans", "Helvetica Neue", Arial, sans-serif',
    fontSize: '14px',
    lineHeight: '27px',
    position: 'relative',
    color: '#000000',

    ':hover': {},
    ':active': {}
  },

  labelDark: {
    color: '#ffffff'
  },

  svg: {
    position: 'absolute',
    top: '6px',
    left: '5px',
    color: '#fff',
    height: '16px'
  }
};

var CheckboxWindows = (function (_Component) {
  _inherits(CheckboxWindows, _Component);

  _createClass(CheckboxWindows, null, [{
    key: 'propTypes',
    value: {
      color: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.bool]),
      label: _react.PropTypes.string,
      onChange: _react.PropTypes.func
    },
    enumerable: true
  }]);

  function CheckboxWindows(props) {
    var _this = this;

    _classCallCheck(this, _CheckboxWindows);

    _get(Object.getPrototypeOf(_CheckboxWindows.prototype), 'constructor', this).call(this);

    this.onChange = function (event) {
      _this.setState({ checked: event.target.checked });
      if (_this.props.onChange) {
        _this.props.onChange(event);
      }
    };

    this.state = {
      checked: props.defaultChecked === true
    };
  }

  _createClass(CheckboxWindows, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var label = _props.label;
      var color = _props.color;

      var props = _objectWithoutProperties(_props, ['style', 'label', 'color']);

      var componentStyle = _extends({}, styles.checkbox, style);
      var checkedStyle = { display: 'none' };
      var labelStyle = styles.label;

      componentStyle = _extends({}, componentStyle, {
        visibility: this.state.visible ? 'visible' : 'hidden',
        display: this.state.display ? 'inline-block' : 'none'
      });

      if (this.state.requestedTheme === 'dark') {
        componentStyle = _extends({}, componentStyle, styles.checkboxDark);
        labelStyle = _extends({}, labelStyle, styles.labelDark);
      }

      if (this.state.checked) {
        checkedStyle = styles.svg;
        componentStyle = _extends({}, componentStyle, this.state.requestedTheme === 'dark' ? styles['checkboxDark:checked'] : styles['checkbox:checked']);

        switch (color) {
          case 'blue':
            break;
          default:
            if (color) {
              componentStyle = _extends({}, componentStyle, {
                backgroundColor: color,
                borderColor: color
              });
            } else {
              componentStyle = _extends({}, componentStyle, {
                backgroundColor: this.state.color,
                borderColor: this.state.color
              });
            }
            break;
        }
      }

      if ((0, _radium.getState)(this.state, null, ':active')) {
        componentStyle = _extends({}, componentStyle, this.state.requestedTheme === 'dark' ? styles['checkboxDark:active'] : styles['checkbox:active']);
      } else if ((0, _radium.getState)(this.state, null, ':hover')) {
        componentStyle = _extends({}, componentStyle, this.state.requestedTheme === 'dark' ? styles['checkboxDark:hover'] : styles['checkbox:hover']);
      }

      return _react2['default'].createElement(
        'label',
        { style: labelStyle },
        _react2['default'].createElement('input', _extends({
          ref: 'element',
          type: 'checkbox',
          style: componentStyle,
          checked: this.state.checked,
          onChange: this.onChange
        }, props)),
        _react2['default'].createElement(
          'svg',
          { x: '0px', y: '0px', viewBox: '0 0 6.4 6.4', style: checkedStyle },
          _react2['default'].createElement('polygon', { fill: '#fff', points: '0,3.3 2.2,5.5 6.4,1.23 6.1,0.9 2.2,4.8 0.3,2.9 ' })
        ),
        label
      );
    }
  }]);

  var _CheckboxWindows = CheckboxWindows;
  CheckboxWindows = (0, _DesktopComponent2['default'])(CheckboxWindows) || CheckboxWindows;
  return CheckboxWindows;
})(_react.Component);

exports['default'] = CheckboxWindows;
module.exports = exports['default'];