'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports['default'] = DesktopComponent;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _Color = require('./Color');

var WindowState = 'WindowState';

exports.WindowState = WindowState;
function ExtendComposedComponent(ComposedComponent) {
  var windowStateEnabled = this.windowStateEnabled ? true : false;

  var Compoment = (function (_ComposedComponent) {
    _inherits(Compoment, _ComposedComponent);

    _createClass(Compoment, null, [{
      key: 'propTypes',
      value: _extends({
        children: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.element, _react.PropTypes.array]),
        style: _react.PropTypes.object,
        visible: _react.PropTypes.bool,
        display: _react.PropTypes.bool,
        color: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.bool]),
        background: _react.PropTypes.string,
        requestedTheme: _react.PropTypes.string
      }, ComposedComponent.propTypes),
      enumerable: true
    }, {
      key: 'childContextTypes',
      value: _extends({
        parent: _react.PropTypes.oneOfType([_react.PropTypes.element, _react.PropTypes.object]),
        color: _react.PropTypes.string,
        background: _react.PropTypes.string,
        requestedTheme: _react.PropTypes.string,
        storage: _react.PropTypes.object
      }, ComposedComponent.childContextTypes),
      enumerable: true
    }, {
      key: 'contextTypes',
      value: _extends({
        parent: _react.PropTypes.oneOfType([_react.PropTypes.element, _react.PropTypes.object]),
        color: _react.PropTypes.string,
        background: _react.PropTypes.string,
        requestedTheme: _react.PropTypes.string,
        storage: _react.PropTypes.object
      }, ComposedComponent.contextTypes),
      enumerable: true
    }]);

    function Compoment(props, context, updater) {
      var _this = this;

      _classCallCheck(this, _Compoment);

      var visible = props.visible;
      var display = props.display;
      var requestedTheme = props.requestedTheme;
      var storage = props.storage;
      var color = props.color;
      var background = props.background;

      var properties = _objectWithoutProperties(props, ['visible', 'display', 'requestedTheme', 'storage', 'color', 'background']);

      _get(Object.getPrototypeOf(_Compoment.prototype), 'constructor', this).call(this, props, context, updater);

      this.windowFocus = function () {
        if (windowStateEnabled) {
          _this.setState({ windowFocused: true });
        }
      };

      this.windowBlur = function () {
        if (windowStateEnabled) {
          _this.setState({ windowFocused: false });
        }
      };

      this._requestedTheme = requestedTheme;
      this._background = background;
      this._color = color;

      if (!this.context) {
        this.context = {};
      }
      if (!this.state) {
        this.state = {};
      }
      if (!this.state.visible) {
        this.state.visible = visible !== false;
      }
      if (!this.state.display) {
        this.state.display = display !== false;
      }

      if (!context.storage) {
        this.context.storage = storage ? storage : null;
      }
      this.storage = storage ? storage : this.context.storage;

      if (!context.requestedTheme) {
        this.context.requestedTheme = requestedTheme ? requestedTheme : 'light';
      }
      this.state.requestedTheme = requestedTheme ? requestedTheme : this.context.requestedTheme;

      if (!context.color) {
        this.context.color = color && typeof color !== 'boolean' ? (0, _Color.convertColor)(color) : (0, _Color.convertColor)('blue');
      }
      this.state.color = color && typeof color !== 'boolean' ? (0, _Color.convertColor)(color) : this.context.color;

      if (!context.background) {
        this.context.background = background ? (0, _Color.convertColor)(background) : null;
      }
      this.state.background = background ? (0, _Color.convertColor)(background) : this.context.background;

      if (windowStateEnabled) {
        this.state.windowFocused = true;
      }
    }

    _createClass(Compoment, [{
      key: 'getChildContext',
      value: function getChildContext() {
        var childContext = {
          parent: this,
          color: this.state.color,
          background: this.state.background,
          requestedTheme: this.state.requestedTheme,
          storage: this.storage
        };

        if (_get(Object.getPrototypeOf(_Compoment.prototype), 'getChildContext', this)) {
          return _extends({}, childContext, _get(Object.getPrototypeOf(_Compoment.prototype), 'getChildContext', this).call(this));
        }

        return childContext;
      }
    }, {
      key: 'setState',
      value: function setState(state) {
        if (state.requestedTheme) {
          this._updateRequestedTheme = true;
          this.context.requestedTheme = state.requestedTheme;
        }
        if (state.color) {
          this._updateColor = true;
          this.context.color = state.color;
        }
        if (state.background) {
          this._updateBackground = true;
          this.context.background = state.background;
        }
        _get(Object.getPrototypeOf(_Compoment.prototype), 'setState', this).call(this, state);
      }
    }, {
      key: 'componentDidMount',
      value: function componentDidMount() {
        if (window && windowStateEnabled) {
          window.addEventListener('focus', this.windowFocus);
          window.addEventListener('blur', this.windowBlur);
        }

        if (_get(Object.getPrototypeOf(_Compoment.prototype), 'getPlaceholderStyle', this)) {
          this.applyPlaceholderStyle();
        }

        if (_get(Object.getPrototypeOf(_Compoment.prototype), 'componentDidMount', this)) {
          _get(Object.getPrototypeOf(_Compoment.prototype), 'componentDidMount', this).call(this);
        }
      }
    }, {
      key: 'componentDidUpdate',
      value: function componentDidUpdate() {
        if (_get(Object.getPrototypeOf(_Compoment.prototype), 'getPlaceholderStyle', this)) {
          if (JSON.stringify(this._currentPlaceholderStyle) != JSON.stringify(_get(Object.getPrototypeOf(_Compoment.prototype), 'getPlaceholderStyle', this).call(this))) {
            this.applyPlaceholderStyle();
          }
        }

        if (_get(Object.getPrototypeOf(_Compoment.prototype), 'componentDidUpdate', this)) {
          _get(Object.getPrototypeOf(_Compoment.prototype), 'componentDidUpdate', this).call(this);
        }
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        if (window && windowStateEnabled) {
          window.removeEventListener('focus', this.windowFocus);
          window.removeEventListener('blur', this.windowBlur);
        }
        if (_get(Object.getPrototypeOf(_Compoment.prototype), 'componentWillUnmount', this)) {
          _get(Object.getPrototypeOf(_Compoment.prototype), 'componentWillUnmount', this).call(this);
        }
      }
    }, {
      key: 'render',
      value: function render() {
        if (!this._updateRequestedTheme && !this._requestedTheme) {
          this.state.requestedTheme = this.context.requestedTheme;
        }
        this._updateRequestedTheme = null;

        if (!this._updateColor && !this._color) {
          this.state.color = this.context.color;
        }
        this._updateColor = null;

        if (!this._updateBackground && !this._background) {
          this.state.background = this.context.background;
        }
        this._updateBackground = null;

        for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
          params[_key] = arguments[_key];
        }

        var rendered = _get(Object.getPrototypeOf(_Compoment.prototype), 'render', this).call(this, params);

        if (_get(Object.getPrototypeOf(_Compoment.prototype), 'getPlaceholderStyle', this)) {
          rendered = _react2['default'].createElement(
            'div',
            { ref: 'container' },
            rendered
          );
        }

        return rendered;
      }
    }, {
      key: 'applyPlaceholderStyle',
      value: function applyPlaceholderStyle() {
        if (this._currentPlaceholderStyleElement) {
          this._currentPlaceholderStyleElement.parentNode.removeChild(this._currentPlaceholderStyleElement);
        }

        var container = _reactDom2['default'].findDOMNode(this.refs.container);
        var id = Compoment.generateUniqueId();
        container.setAttribute('data-reactdesktopid', id);

        var selector = '[data-reactdesktopid="' + id + '"]';

        this._currentPlaceholderStyle = _extends({}, _get(Object.getPrototypeOf(_Compoment.prototype), 'getPlaceholderStyle', this).call(this));
        var style = _extends({}, _get(Object.getPrototypeOf(_Compoment.prototype), 'getPlaceholderStyle', this).call(this));

        var styles = { 0: style };
        if (style[':hover']) {
          styles = _extends({}, styles, { ':hover': style[':hover'] });
          delete styles[0][':hover'];
        }

        if (style[':active']) {
          styles = _extends({}, styles, { ':active': style[':active'] });
          delete styles[0][':active'];
        }

        if (style[':focus']) {
          styles = _extends({}, styles, { ':focus': style[':focus'] });
          delete styles[0][':focus'];
        }

        var rules = {};

        for (var prop in styles) {
          if (styles.hasOwnProperty(prop)) {
            rules[selector + ' input' + (prop !== '0' ? prop : '') + '::-webkit-input-placeholder'] = styles[prop];
            rules[selector + ' input' + (prop !== '0' ? prop : '') + '::-moz-placeholder'] = styles[prop];
            rules[selector + ' input' + (prop !== '0' ? prop : '') + ':-ms-input-placeholder'] = styles[prop];
            rules[selector + ' input' + (prop !== '0' ? prop : '') + ':placeholder'] = styles[prop];
          }
        }

        var tmpContainer = document.createElement('div');
        _reactDom2['default'].render(_react2['default'].createElement(_radium.Style, { rules: rules }), tmpContainer);
        container.appendChild(this._currentPlaceholderStyleElement = tmpContainer.firstChild);
      }
    }], [{
      key: 'generateUniqueId',
      value: function generateUniqueId() {
        return Math.floor(Math.random() * 10000 + 1) + '-' + +Math.floor(Math.random() * 10000 + 1) + '-' + +Math.floor(Math.random() * 10000 + 1) + '-' + +Math.floor(Math.random() * 10000 + 1) + '-' + +Math.floor(Math.random() * 10000 + 1) + '-' + +Math.floor(Math.random() * 10000 + 1) + '-' + +Math.floor(Math.random() * 10000 + 1) + '-' + Math.floor(Math.random() * 100000000000000);
      }
    }]);

    var _Compoment = Compoment;
    Compoment = (0, _radium2['default'])(Compoment) || Compoment;
    return Compoment;
  })(ComposedComponent);

  return Compoment;
}

function DesktopComponent() {
  for (var _len2 = arguments.length, options = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    options[_key2] = arguments[_key2];
  }

  if (options.length === 1 && typeof options[0] === 'function') {
    return ExtendComposedComponent.apply({}, [].concat(options));
  }

  return ExtendComposedComponent.bind({
    windowStateEnabled: options.indexOf(WindowState) !== -1
  });
}