'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Styling = require('../../Styling');

var _Styling2 = _interopRequireDefault(_Styling);

var _WindowState = require('../../WindowState');

var _WindowState2 = _interopRequireDefault(_WindowState);

var styles = {
  tab: {
    WebkitUserSelect: 'none',
    cursor: 'default',
    backgroundColor: '#ffffff',
    borderTopWidth: '1px',
    borderTopStyle: 'solid',
    borderTopColor: '#c7c7c7',
    borderBottomWidth: '1px',
    borderBottomStyle: 'solid',
    borderBottomColor: '#a6a6a6',
    borderRightWidth: '1px',
    borderRightStyle: 'solid',
    borderRightColor: '#d8d8d8',
    paddingTop: '1px',
    paddingBottom: '1px',
    paddingLeft: '11px',
    paddingRight: '11px',
    lineHeight: '16px',
    fontFamily: '"San Francisco", "Helvetica Neue", "Lucida Grande", Arial, sans-serif',
    fontSize: '13px',
    boxShadow: '0 1px rgba(0, 0, 0, .039), 0 0 .5px rgba(0, 0, 0, .1)',

    ':active': {
      backgroundColor: '#f0f0f0'
    }
  },

  firstChild: {
    borderLeftWidth: '1px',
    borderLeftStyle: 'solid',
    borderLeftColor: '#b8b8b8',
    borderTopLeftRadius: '5px',
    borderBottomLeftRadius: '5px'
  },

  lastChild: {
    borderRightColor: '#b8b8b8',
    borderTopRightRadius: '5px',
    borderBottomRightRadius: '5px'
  },

  nextSelected: {
    borderRightWidth: '0px'
  },

  selected: {
    backgroundImage: '-webkit-linear-gradient(top, #6cb3fa 0%, #087eff 100%)',
    borderTopColor: '#4ca2f9',
    borderBottomColor: '#015cff',
    borderLeftColor: '#267ffc',
    borderRightColor: '#267ffc',
    color: 'rgba(255, 255, 255, .9)',
    borderRightWidth: '0px',
    paddingRight: '12px',
    paddingLeft: '12px'
  },

  selectedActive: {
    backgroundImage: '-webkit-linear-gradient(top, #4c98fe 0%, #0564e3 100%) !important',
    borderTopColor: '#247fff !important',
    borderBottomColor: '#003ddb !important',
    borderLeftColor: '#125eed !important',
    borderRightColor: '#125eed !important',
    color: 'rgba(255, 255, 255, .9)'
  },

  selectedUnfocused: {
    backgroundImage: '-webkit-linear-gradient(top, #e5e5e5 0%, #e5e5e5 100%)',
    borderTopColor: '#c7c7c7',
    borderBottomColor: '#a6a6a6',
    borderRightColor: '#b7b7b7',
    borderLeftColor: '#b7b7b7',
    borderRightWidth: '0px',
    paddingRight: '12px',
    paddingLeft: '12px',
    color: '#000000'
  }
};

var Tab = (function (_Component) {
  _inherits(Tab, _Component);

  _createClass(Tab, null, [{
    key: 'propTypes',
    value: {
      title: _react.PropTypes.string.isRequired,
      style: _react.PropTypes.object,
      selected: _react.PropTypes.bool.isRequired,
      tabId: _react.PropTypes.number,
      firstChild: _react.PropTypes.bool,
      lastChild: _react.PropTypes.bool,
      nextSelected: _react.PropTypes.bool,
      onPress: _react.PropTypes.func.isRequired
    },
    enumerable: true
  }]);

  function Tab(props) {
    _classCallCheck(this, _Tab);

    _get(Object.getPrototypeOf(_Tab.prototype), 'constructor', this).call(this, props);
    this.state = {
      selected: props.selected,
      windowFocused: true,
      activeStyle: null
    };
  }

  _createClass(Tab, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var nextSelected = _props.nextSelected;

      var props = _objectWithoutProperties(_props, ['style', 'nextSelected']);

      var cssStyle = styles.tab;
      var componentStyle = style;

      if (this.props.firstChild) {
        componentStyle = (0, _Styling.mergeStyles)(componentStyle, styles.firstChild);
      }

      if (this.props.lastChild) {
        componentStyle = (0, _Styling.mergeStyles)(componentStyle, styles.lastChild);
      }

      if (nextSelected) {
        componentStyle = (0, _Styling.mergeStyles)(componentStyle, styles.nextSelected);
      }

      if (this.state.selected && this.state.windowFocused) {
        componentStyle = (0, _Styling.mergeStyles)(componentStyle, styles.selected);
        if (this.props.firstChild) {
          componentStyle = (0, _Styling.mergeStyles)(componentStyle, { paddingLeft: '11px' });
        }
        if (this.props.lastChild) {
          componentStyle = (0, _Styling.mergeStyles)(componentStyle, { borderRightWidth: '1px', paddingRight: '11px' });
        }
        cssStyle = (0, _Styling.mergeStyles)(cssStyle, { ':active': styles.selectedActive });
      } else if (this.state.selected) {
        componentStyle = (0, _Styling.mergeStyles)(componentStyle, styles.selectedUnfocused);
        if (this.props.firstChild) {
          componentStyle = (0, _Styling.mergeStyles)(componentStyle, { paddingLeft: '11px' });
        }
        if (this.props.lastChild) {
          componentStyle = (0, _Styling.mergeStyles)(componentStyle, { borderRightWidth: '1px', paddingRight: '11px' });
        }
      }

      return _react2['default'].createElement(
        'div',
        {
          ref: 'element',
          onClick: this.props.onPress,
          'data-style': (0, _Styling.applyStyle)(cssStyle),
          style: componentStyle
        },
        this.props.title
      );
    }
  }]);

  var _Tab = Tab;
  Tab = (0, _Styling2['default'])(Tab) || Tab;
  Tab = (0, _WindowState2['default'])(Tab) || Tab;
  return Tab;
})(_react.Component);

exports['default'] = Tab;
module.exports = exports['default'];