'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DesktopComponent = require('../../DesktopComponent');

var _DesktopComponent2 = _interopRequireDefault(_DesktopComponent);

var _radium = require('radium');

var appear = (0, _radium.keyframes)({
  '0%': {
    opacity: 0
  },
  '29%': {
    opacity: 0,
    transform: 'translateY(9px)'
  },
  '30%': {
    opacity: .35,
    transform: 'translateY(9px)'
  },
  '100%': {
    opacity: 1,
    transform: 'translateY(0)'
  }
}, 'Title');

var fadeOut = (0, _radium.keyframes)({
  '0%': {
    opacity: 1
  },
  '100%': {
    opacity: 0
  }
}, 'span');

var styles = {
  title: {
    position: 'relative',
    color: '#000000',
    height: '48px',
    display: 'flex',
    alignItems: 'center',
    fontFamily: '"Segoe UI", Frutiger, "Frutiger Linotype", "Dejavu Sans", "Helvetica Neue", Arial, sans-serif',
    fontSize: '15px',
    textTransform: 'uppercase',
    padding: '0 24px',
    overflow: 'hidden'
  },

  titleDark: {
    color: '#ffffff'
  },

  fadeSpanStyle: {
    position: 'absolute',
    top: '0',
    left: '0',
    animation: fadeOut + ' 100ms forwards'
  },

  test: {
    animation: appear + ' 300ms'
  }
};

var Title = (function (_Component) {
  _inherits(Title, _Component);

  function Title(props, context, updater) {
    _classCallCheck(this, _Title);

    var parentRequestedTheme = props.parentRequestedTheme;
    var selected = props.selected;

    var properties = _objectWithoutProperties(props, ['parentRequestedTheme', 'selected']);

    _get(Object.getPrototypeOf(_Title.prototype), 'constructor', this).call(this, properties, context, updater);
    if (selected) {
      this.initialShow = true;
    }
    this.state = {
      selected: selected,
      parentRequestedTheme: parentRequestedTheme
    };
  }

  _createClass(Title, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return nextState.selected !== this.state.selected || nextState.parentRequestedTheme !== this.state.parentRequestedTheme || nextState.requestedTheme !== this.state.requestedTheme || nextState.visible !== this.state.visible || nextState.display !== this.state.display;
    }
  }, {
    key: 'componentWillUpdate',
    value: function componentWillUpdate(nextProps, nextState) {
      this.state.animate = nextState.selected && !this.state.selected;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var children = _props.children;

      var componentStyle = _extends({}, styles.title, style);
      var fadeSpanStyle = _extends({}, styles.title, style, styles.fadeSpanStyle);
      var spanStyle = undefined;

      if (this.state.parentRequestedTheme === 'dark') {
        componentStyle = _extends({}, componentStyle, styles.titleDark);
        fadeSpanStyle = _extends({}, fadeSpanStyle, styles.titleDark);
      }

      var fadeSpan = undefined;
      if (this.state.selected && !this.initialShow) {
        if (this.content.item.splitView.currentTitle !== children) {
          fadeSpan = _react2['default'].createElement(
            'span',
            { style: fadeSpanStyle },
            this.content.item.splitView.currentTitle
          );
        }
        spanStyle = styles.test;
      }

      if (this.state.selected) {
        this.content.item.splitView.currentTitle = children;
      }
      this.initialShow = false;

      return _react2['default'].createElement(
        'div',
        { style: componentStyle },
        fadeSpan,
        _react2['default'].createElement(
          'span',
          { style: spanStyle },
          children
        )
      );
    }
  }, {
    key: 'content',
    get: function get() {
      return this.context.parent;
    }
  }]);

  var _Title = Title;
  Title = (0, _DesktopComponent2['default'])(Title) || Title;
  return Title;
})(_react.Component);

exports['default'] = Title;
module.exports = exports['default'];