'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DesktopComponent = require('../../../DesktopComponent');

var _DesktopComponent2 = _interopRequireDefault(_DesktopComponent);

var _IconWindows = require('./Icon.windows');

var _IconWindows2 = _interopRequireDefault(_IconWindows);

var _Color = require('../../../Color');

var styles = {
  anchor: {
    display: 'flex',
    alignItems: 'center',

    ':hover': {
      backgroundColor: 'rgba(255, 255, 255, .1)'
    },

    ':active': {
      backgroundColor: 'rgba(255, 255, 255, .2)'
    }
  },

  span: {
    display: 'flex',
    alignItems: 'center',
    color: '#000000',
    lineHeight: '44px',
    fontFamily: '"Segoe UI", Frutiger, "Frutiger Linotype", "Dejavu Sans", "Helvetica Neue", Arial, sans-serif',
    fontSize: '15px',
    letterSpacing: '0.4pt',
    padding: '0 16px',
    transition: 'transform .1s ease-in'
  },

  spanDark: {
    color: '#ffffff'
  },

  pushTransformHover: {
    transition: 'transform .1s ease-in'
  },

  pushTransformActive: {
    transform: 'scale(0.97)',
    transition: 'transform 0s ease-in'
  }
};

var Item = (function (_Component) {
  _inherits(Item, _Component);

  function Item() {
    _classCallCheck(this, _Item);

    _get(Object.getPrototypeOf(_Item.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Item, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;
      var onPress = _props.onPress;

      var props = _objectWithoutProperties(_props, ['children', 'style', 'onPress']);

      var title = children.props.title;
      var selected = children.props.selected;
      var ItemIcon = children.props.icon;
      var anchorStyle = _extends({}, styles.anchor, style);
      var spanStyle = _extends({}, styles.span, style);

      if (this.state.requestedTheme === 'dark') {
        spanStyle = _extends({}, spanStyle, styles.spanDark);
      }

      if (selected) {
        anchorStyle = _extends({}, anchorStyle, {
          backgroundColor: (0, _Color.transparentize)(this.state.color, .4),
          ':hover': _extends({}, anchorStyle[':hover'], {
            backgroundColor: (0, _Color.transparentize)(this.state.color, .2)
          }),
          ':active': _extends({}, anchorStyle[':active'], {
            backgroundColor: (0, _Color.transparentize)(this.state.color, .1)
          })
        });
      }

      if (this.context.push) {
        spanStyle[':hover'] = _extends({}, spanStyle[':hover'], styles.pushTransformHover);
        spanStyle[':active'] = _extends({}, spanStyle[':active'], styles.pushTransformActive);
      }

      return _react2['default'].createElement(
        'a',
        _extends({
          ref: 'anchor',
          onClick: onPress,
          style: anchorStyle
        }, props),
        _react2['default'].createElement(
          'span',
          {
            ref: 'span',
            style: spanStyle
          },
          _react2['default'].createElement(_IconWindows2['default'], { icon: ItemIcon }),
          title
        )
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      onPress: _react.PropTypes.func
    },
    enumerable: true
  }, {
    key: 'contextTypes',
    value: {
      push: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  var _Item = Item;
  Item = (0, _DesktopComponent2['default'])(Item) || Item;
  return Item;
})(_react.Component);

exports['default'] = Item;
module.exports = exports['default'];