'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _DesktopComponent = require('../../DesktopComponent');

var _DesktopComponent2 = _interopRequireDefault(_DesktopComponent);

var _ItemItemWindows = require('./Item/Item.windows');

var _ItemItemWindows2 = _interopRequireDefault(_ItemItemWindows);

var _ButtonButtonWindows = require('./Button/Button.windows');

var _ButtonButtonWindows2 = _interopRequireDefault(_ButtonButtonWindows);

var styles = {
  pane: {
    display: 'flex',
    position: 'relative',
    flexGrow: '0',
    flexShrink: '0',
    flexDirection: 'column',
    width: '200px',
    overflow: 'hidden'
  },

  padding: {
    height: '48px'
  },

  buttonStyle: {
    position: 'absolute',
    padding: '8px 10px',
    top: '7px',
    left: '4px',
    width: '20px',
    height: '20px'
  }
};

var Pane = (function (_Component) {
  _inherits(Pane, _Component);

  _createClass(Pane, null, [{
    key: 'Item',
    value: _ItemItemWindows2['default'],
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      compactLength: _react.PropTypes.number,
      openLength: _react.PropTypes.number,
      placement: _react.PropTypes.string,
      isOpen: _react.PropTypes.bool,
      onPaneToggle: _react.PropTypes.func
    },
    enumerable: true
  }, {
    key: 'contextTypes',
    value: {
      compactLength: _react.PropTypes.number,
      openLength: _react.PropTypes.number,
      placement: _react.PropTypes.string,
      isOpen: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function Pane(props, context, updater) {
    var _this = this;

    _classCallCheck(this, _Pane);

    _get(Object.getPrototypeOf(_Pane.prototype), 'constructor', this).call(this, props, context, updater);

    this.toggleOpen = function () {
      _this.setState({ isOpen: !_this.state.isOpen });
      if (_this.context.storage) {
        var reactId = (0, _reactDom.findDOMNode)(_this).getAttribute('data-reactid');
        _this.context.storage[reactId + '-SplitViewPane-isOpen'] = !_this.state.isOpen;
      }
      if (_this.props.onPaneToggle) {
        _this.props.onPaneToggle(!_this.state.isOpen);
      }
    };

    this.state = {
      isOpen: context.isOpen !== false
    };
  }

  _createClass(Pane, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var reactId = (0, _reactDom.findDOMNode)(this).getAttribute('data-reactid');
      var key = reactId + '-SplitViewPane-isOpen';
      if (this.context.storage && typeof this.context.storage[key] !== 'undefined') {
        var value = this.context.storage[key] === 'true';
        if (value != this.state.isOpen) {
          this.toggleOpen();
        }
      }
    }
  }, {
    key: 'filterChildren',
    value: function filterChildren(children) {
      return _react.Children.map(children, function (child) {
        var onPress = child.props.onPress;

        return _react2['default'].createElement(
          _ItemItemWindows2['default'],
          { onPress: onPress },
          child
        );
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;

      var props = _objectWithoutProperties(_props, ['children', 'style']);

      children = this.filterChildren(children);

      var componentStyle = _extends({}, styles.pane, style);
      if (this.context.openLength) {
        componentStyle.width = this.context.openLength + 'px';
      }

      if (!this.state.isOpen) {
        componentStyle.width = this.context.compactLength ? this.context.compactLength : '48px';
      }

      return _react2['default'].createElement(
        'div',
        _extends({
          style: componentStyle
        }, props),
        _react2['default'].createElement('div', { style: styles.padding }),
        _react2['default'].createElement(_ButtonButtonWindows2['default'], { style: styles.buttonStyle, onClick: this.toggleOpen }),
        children
      );
    }
  }]);

  var _Pane = Pane;
  Pane = (0, _DesktopComponent2['default'])(Pane) || Pane;
  return Pane;
})(_react.Component);

exports['default'] = Pane;
module.exports = exports['default'];