'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TextBlockTextBlockWindows = require('../TextBlock/TextBlock.windows');

var _TextBlockTextBlockWindows2 = _interopRequireDefault(_TextBlockTextBlockWindows);

var _DesktopComponent = require('../DesktopComponent');

var _DesktopComponent2 = _interopRequireDefault(_DesktopComponent);

var styles = {
  textBox: {
    userSelect: 'none',
    borderWidth: '2px',
    borderStyle: 'solid',
    borderColor: 'rgba(148, 148, 148, 1)',
    padding: '2px 10px 3px 10px',
    lineHeight: '23px',
    fontFamily: '"Segoe UI", Frutiger, "Frutiger Linotype", "Dejavu Sans", "Helvetica Neue", Arial, sans-serif',
    fontSize: '15px',
    fontWeight: '100',
    color: '#000000',
    backgroundColor: 'rgba(255, 255, 255, .35)',

    ':hover': {
      borderColor: 'rgba(100, 100, 100, 1)',
      backgroundColor: 'rgba(255, 255, 255, .5)'
    },

    ':focus': {
      outline: 'none',
      borderColor: 'rgba(0, 120, 215, 1)',
      backgroundColor: 'rgba(255, 255, 255, 1)'
    }
  },

  textBoxDarkTheme: {
    borderColor: 'rgba(255, 255, 255, .41)',
    backgroundColor: 'rgba(0, 0, 0, .4)',
    color: '#ffffff',

    ':hover': {
      borderColor: 'rgba(255, 255, 255, .94)',
      backgroundColor: 'rgba(0, 0, 0, .6)'
    },

    ':focus': {
      outline: 'none',
      borderColor: 'rgba(0, 120, 215, 1)',
      backgroundColor: 'rgba(255, 255, 255, 1)',
      color: '#000000'
    }
  },

  ':placeholder': {
    color: '#636363'
  },

  ':placeholderDarkTheme': {
    color: 'rgba(255, 255, 255, .64)',

    ':focus': {
      color: 'rgba(0, 0, 0, .41)'
    }
  }
};

var TextBoxWindows = (function (_Component) {
  _inherits(TextBoxWindows, _Component);

  function TextBoxWindows() {
    _classCallCheck(this, _TextBoxWindows);

    _get(Object.getPrototypeOf(_TextBoxWindows.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(TextBoxWindows, [{
    key: 'getPlaceholderStyle',
    value: function getPlaceholderStyle() {
      return this.state.requestedTheme === 'dark' ? styles[':placeholderDarkTheme'] : styles[':placeholder'];
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var header = _props.header;
      var style = _props.style;

      var props = _objectWithoutProperties(_props, ['header', 'style']);

      var componentStyle = _extends({}, styles.textBox, style, {
        visibility: this.state.visible ? 'visible' : 'hidden',
        display: this.state.display ? 'block' : 'none'
      });

      if (this.state.requestedTheme === 'dark') {
        componentStyle = _extends({}, componentStyle, styles.textBoxDarkTheme);
      }

      componentStyle[':focus'] = _extends({}, componentStyle[':focus'], { borderColor: this.state.color });

      var input = _react2['default'].createElement('input', _extends({
        ref: 'input',
        type: 'text',
        style: componentStyle
      }, props));

      if (header) {
        return _react2['default'].createElement(
          'div',
          null,
          _react2['default'].createElement(
            _TextBlockTextBlockWindows2['default'],
            { style: { marginBottom: '5px' } },
            header
          ),
          input
        );
      }
      return input;
    }
  }], [{
    key: 'propTypes',
    value: {
      header: _react.PropTypes.string
    },
    enumerable: true
  }]);

  var _TextBoxWindows = TextBoxWindows;
  TextBoxWindows = (0, _DesktopComponent2['default'])(TextBoxWindows) || TextBoxWindows;
  return TextBoxWindows;
})(_react.Component);

exports['default'] = TextBoxWindows;
module.exports = exports['default'];