'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _WindowState = require('../../WindowState');

var _WindowState2 = _interopRequireDefault(_WindowState);

var styles = {
  button: {
    userSelect: 'none',
    WebkitAppRegion: 'no-drag',
    cursor: 'default',
    width: '10px',
    height: '10px',
    borderWidth: '1px',
    borderStyle: 'solid',
    borderRadius: '50%',
    marginBottom: '.5px',
    marginLeft: '4px',
    marginRight: '4px',
    lineHeight: 0,
    backgroundColor: '#28c940',
    borderColor: '#12ac28',

    ':active': {
      backgroundColor: '#1f9a31',
      borderColor: '#128622'
    }
  },

  unfocused: {
    backgroundColor: '#dddddd',
    borderColor: '#d0d0d0'
  },

  icon: {
    width: '6px',
    height: '6px',
    marginTop: '2px',
    marginLeft: '2px'
  }
};

var Resize = (function (_Component) {
  _inherits(Resize, _Component);

  _createClass(Resize, null, [{
    key: 'propTypes',
    value: {
      style: _react.PropTypes.object
    },
    enumerable: true
  }]);

  function Resize() {
    _classCallCheck(this, _Resize);

    _get(Object.getPrototypeOf(_Resize.prototype), 'constructor', this).call(this);
    this.state = { iconVisible: false, windowFocused: true };
  }

  _createClass(Resize, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;

      var props = _objectWithoutProperties(_props, ['style']);

      var iconStyle = _extends({}, styles.icon, {
        opacity: this.state.iconVisible ? 1 : 0
      });

      var componentStyle = _extends({}, styles.button, style);
      if (!this.state.windowFocused && !this.state.iconVisible) {
        componentStyle = _extends({}, componentStyle, styles.unfocused);
      }

      return _react2['default'].createElement(
        'a',
        _extends({
          style: componentStyle
        }, props),
        _react2['default'].createElement(
          'svg',
          { x: '0px', y: '0px', viewBox: '0 0 6 5.9', style: iconStyle },
          _react2['default'].createElement('path', { fill: '#006400', d: 'M5.4,0h-4L6,4.5V0.6C5.7,0.6,5.3,0.3,5.4,0z' }),
          _react2['default'].createElement('path', { fill: '#006400', d: 'M0.6,5.9h4L0,1.4l0,3.9C0.3,5.3,0.6,5.6,0.6,5.9z' })
        )
      );
    }
  }]);

  var _Resize = Resize;
  Resize = (0, _radium2['default'])(Resize) || Resize;
  Resize = (0, _WindowState2['default'])(Resize) || Resize;
  return Resize;
})(_react.Component);

exports['default'] = Resize;
module.exports = exports['default'];