'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DesktopComponent = require('../../DesktopComponent');

var _DesktopComponent2 = _interopRequireDefault(_DesktopComponent);

var _Color = require('../../Color');

var styles = {
  button: {
    userSelect: 'none',
    WebkitAppRegion: 'no-drag',
    cursor: 'default',
    width: '46px',
    height: '100%',
    lineHeight: 0,
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',

    ':hover': {
      transition: 'background-color 0.1s',
      backgroundColor: '#e5e5e5'
    },

    ':active': {
      backgroundColor: '#cccccc'
    }
  },

  buttonColorBackground: {
    ':hover': {
      transition: 'background-color 0.1s',
      backgroundColor: 'rgba(255, 255, 255, .13)'
    },

    ':active': {
      backgroundColor: 'rgba(255, 255, 255, .23)'
    }
  },

  icon: {
    width: '10px',
    height: '10px'
  }
};

var Maximize = (function (_Component) {
  _inherits(Maximize, _Component);

  function Maximize() {
    _classCallCheck(this, _Maximize);

    _get(Object.getPrototypeOf(_Maximize.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Maximize, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;

      var props = _objectWithoutProperties(_props, ['style']);

      var svgFill = '#000000';
      if (!this.state.windowFocused && this.state.requestedTheme !== 'dark') {
        svgFill = 'rgba(0, 0, 0, .4)';
      }

      var componentStyle = _extends({}, styles.button, style);
      if (this.state.requestedTheme === 'dark' || this.state.background && (0, _Color.isDarkColor)(this.state.background)) {
        svgFill = '#ffffff';
        componentStyle = _extends({}, componentStyle, styles.buttonColorBackground);
      }

      return _react2['default'].createElement(
        'a',
        _extends({
          style: componentStyle
        }, props),
        _react2['default'].createElement(
          'svg',
          { x: '0px', y: '0px', viewBox: '0 0 10.2 10.2', style: styles.icon },
          _react2['default'].createElement('path', {
            fill: svgFill,
            d: 'M2.1,0v2H0v8.1h8.2v-2h2V0H2.1z M7.2,9.2H1.1V3h6.1V9.2z M9.2,7.1h-1V2H3.1V1h6.1V7.1z'
          })
        )
      );
    }
  }]);

  var _Maximize = Maximize;
  Maximize = (0, _DesktopComponent2['default'])(_DesktopComponent.WindowState)(Maximize) || Maximize;
  return Maximize;
})(_react.Component);

exports['default'] = Maximize;
module.exports = exports['default'];