'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DesktopComponent = require('../DesktopComponent');

var _DesktopComponent2 = _interopRequireDefault(_DesktopComponent);

var _ControlsWindowsControls = require('./Controls.windows/Controls');

var _ControlsWindowsControls2 = _interopRequireDefault(_ControlsWindowsControls);

var styles = {
  titleBar: {
    userSelect: 'none',
    WebkitAppRegion: 'drag',
    cursor: 'default',
    display: 'flex',
    alignItems: 'center',
    height: '31px',
    backgroundColor: '#ffffff'
  },

  titleBarDark: {
    backgroundColor: '#171717'
  },

  title: {
    WebkitUserSelect: 'none',
    cursor: 'default',
    paddingLeft: '12px',
    fontFamily: '"Segoe UI", "Arial"',
    fontSize: '12px',
    color: '#000000',
    flex: 1
  },

  titleDark: {
    color: '#ffffff'
  },

  unfocusedTitle: {
    color: '#a9a9a9'
  }
};

var TitleBar = (function (_Component) {
  _inherits(TitleBar, _Component);

  function TitleBar() {
    _classCallCheck(this, _TitleBar);

    _get(Object.getPrototypeOf(_TitleBar.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(TitleBar, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;
      var background = _props.background;
      var controls = _props.controls;
      var title = _props.title;

      var props = _objectWithoutProperties(_props, ['children', 'style', 'background', 'controls', 'title']);

      var componentStyle = _extends({}, styles.titleBar, style);
      var titleStyle = styles.title;

      if (!this.state.windowFocused && this.state.requestedTheme !== 'dark') {
        titleStyle = _extends({}, titleStyle, styles.unfocusedTitle);
      }

      if (this.state.requestedTheme === 'dark') {
        titleStyle = _extends({}, titleStyle, styles.titleDark);
      }

      componentStyle = _extends({}, componentStyle, {
        visibility: this.state.visible ? 'visible' : 'hidden',
        display: this.state.display ? 'flex' : 'none'
      });

      if (this.context.requestedTheme === 'dark') {
        componentStyle = _extends({}, componentStyle, styles.titleBarDark);
      }

      if (background) {
        componentStyle = _extends({}, componentStyle, { backgroundColor: background });
      } else if (this.state.background) {
        componentStyle = _extends({}, componentStyle, { backgroundColor: this.state.background });
      }

      var controlsComponent = !controls || _react2['default'].createElement(_ControlsWindowsControls2['default'], this.props);
      var titleComponent = !title || _react2['default'].createElement(
        'div',
        { style: titleStyle },
        this.props.title
      );

      return _react2['default'].createElement(
        'div',
        _extends({
          ref: 'element',
          style: componentStyle
        }, props),
        titleComponent,
        controlsComponent,
        children
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      title: _react.PropTypes.string,
      controls: _react.PropTypes.bool,
      onClosePress: _react.PropTypes.func,
      onMinimizePress: _react.PropTypes.func,
      onMaximizePress: _react.PropTypes.func,
      background: _react.PropTypes.string
    },
    enumerable: true
  }]);

  var _TitleBar = TitleBar;
  TitleBar = (0, _DesktopComponent2['default'])(_DesktopComponent.WindowState)(TitleBar) || TitleBar;
  return TitleBar;
})(_react.Component);

exports['default'] = TitleBar;
module.exports = exports['default'];