'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Styling = require('../Styling');

var _TitleBar = require('../TitleBar');

var _TitleBar2 = _interopRequireDefault(_TitleBar);

var _TitleBarTitleBarOsx = require('../TitleBar/TitleBar.osx');

var _TitleBarTitleBarOsx2 = _interopRequireDefault(_TitleBarTitleBarOsx);

var styles = {
  window: {
    WebkitUserSelect: 'none',
    cursor: 'default',
    backgroundColor: '#ececec',
    display: 'flex',
    flexDirection: 'column'
  },

  chrome: {
    borderTopLeftRadius: '4px',
    borderTopRightRadius: '4px',
    borderBottomLeftRadius: '4px',
    borderBottomRightRadius: '4px',
    boxShadow: '0 0 1px rgba(0, 0, 0, .5), ' + // Border
    '0 15px 25px rgba(0, 0, 0, .1), ' + '0 0 30px rgba(0, 0, 0, .06), ' + '0 0 60px rgba(0, 0, 0, .06)'
  },

  content: {
    margin: '24px 20px 20px 20px'
  }
};

var WindowOSX = (function (_Component) {
  _inherits(WindowOSX, _Component);

  _createClass(WindowOSX, null, [{
    key: 'propTypes',
    value: {
      children: _react.PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.element, _react2['default'].PropTypes.array]),
      style: _react.PropTypes.object,
      chrome: _react.PropTypes.bool,
      visible: _react.PropTypes.bool,
      display: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function WindowOSX(props) {
    _classCallCheck(this, WindowOSX);

    _get(Object.getPrototypeOf(WindowOSX.prototype), 'constructor', this).call(this);
    this.state = { visible: props.visible !== false, display: props.display !== false };
  }

  _createClass(WindowOSX, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var chrome = _props.chrome;
      var children = _props.children;
      var visible = _props.visible;
      var display = _props.display;

      var props = _objectWithoutProperties(_props, ['style', 'chrome', 'children', 'visible', 'display']);

      var componentStyle = this.styles;
      if (chrome) {
        componentStyle = (0, _Styling.mergeStyles)(componentStyle, styles.chrome);
      }

      var titleBar = _react.Children.map(children, function (element) {
        if (element.type === _TitleBar2['default'] || element.type === _TitleBarTitleBarOsx2['default']) {
          return element;
        }
      });

      children = _react.Children.map(children, function (element) {
        if (element.type !== _TitleBar2['default'] && element.type !== _TitleBarTitleBarOsx2['default']) {
          return element;
        }
      });

      componentStyle = (0, _Styling.mergeStyles)(componentStyle, {
        visibility: this.state.visible ? 'visible' : 'hidden',
        display: this.state.display ? 'flex' : 'none'
      });

      return _react2['default'].createElement(
        'div',
        _extends({ style: componentStyle }, props),
        titleBar,
        _react2['default'].createElement(
          'div',
          { style: styles.content },
          children
        )
      );
    }
  }, {
    key: 'styles',
    get: function get() {
      if (this.props) {
        return (0, _Styling.mergeStyles)(styles.window, this.props.style);
      }
      return (0, _Styling.mergeStyles)(styles.window, this.props);
    }
  }]);

  return WindowOSX;
})(_react.Component);

exports['default'] = WindowOSX;
module.exports = exports['default'];