'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DesktopComponent = require('../DesktopComponent');

var _DesktopComponent2 = _interopRequireDefault(_DesktopComponent);

var _TitleBarTitleBarWindows = require('../TitleBar/TitleBar.windows');

var _TitleBarTitleBarWindows2 = _interopRequireDefault(_TitleBarTitleBarWindows);

var _GridGridWindows = require('../Grid/Grid.windows');

var _GridGridWindows2 = _interopRequireDefault(_GridGridWindows);

var _SplitViewSplitViewWindows = require('../SplitView/SplitView.windows');

var _SplitViewSplitViewWindows2 = _interopRequireDefault(_SplitViewSplitViewWindows);

var styles = {
  window: {
    WebkitUserSelect: 'none',
    cursor: 'default',
    backgroundColor: '#ffffff',
    display: 'flex',
    flexDirection: 'column',
    width: '100vw',
    height: '100vh'
  },

  windowDark: {
    backgroundColor: '#171717'
  },

  chrome: {
    borderWidth: '1px',
    borderStyle: 'solid',
    boxShadow: '0 2px 11px 3px rgba(0, 0, 0, .2)'
  },

  unfocused: {
    borderColor: '#aaaaaa'
  },

  content: {
    flexGrow: '1',
    display: 'flex'
  }
};

var Window = (function (_Component) {
  _inherits(Window, _Component);

  function Window() {
    _classCallCheck(this, _Window);

    _get(Object.getPrototypeOf(_Window.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Window, [{
    key: 'filterChildren',
    value: function filterChildren() {
      var titleBar = '';
      var otherChildren = [];
      _react.Children.map(this.props.children, function (element) {
        if (element.type === _TitleBarTitleBarWindows2['default']) {
          titleBar = element;
        } else {
          otherChildren = [].concat(_toConsumableArray(otherChildren), [element]);
        }
      });

      return [titleBar].concat(_toConsumableArray(otherChildren));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var chrome = _props.chrome;

      var props = _objectWithoutProperties(_props, ['style', 'chrome']);

      var componentStyle = _extends({}, styles.window, style);
      if (chrome) {
        componentStyle = _extends({}, componentStyle, styles.chrome, {
          borderColor: this.state.color
        });

        if (!this.state.windowFocused) {
          componentStyle = _extends({}, componentStyle, styles.unfocused);
        }
      }

      componentStyle = _extends({}, componentStyle, {
        visibility: this.state.visible ? 'visible' : 'hidden',
        display: this.state.display ? 'flex' : 'none'
      });

      if (this.state.requestedTheme === 'dark') {
        componentStyle = _extends({}, componentStyle, styles.windowDark);
      }

      if (this.state.background) {
        componentStyle = _extends({}, componentStyle, { backgroundColor: this.state.background });
      }

      var _filterChildren = this.filterChildren();

      var _filterChildren2 = _toArray(_filterChildren);

      var titleBar = _filterChildren2[0];

      var children = _filterChildren2.slice(1);

      var content = _react2['default'].createElement(
        _GridGridWindows2['default'],
        { style: styles.content },
        children
      );

      return _react2['default'].createElement(
        'div',
        _extends({
          style: componentStyle
        }, props),
        titleBar,
        content
      );
    }
  }], [{
    key: 'propTypes',
    value: {
      chrome: _react.PropTypes.bool,
      storage: _react.PropTypes.object
    },
    enumerable: true
  }]);

  var _Window = Window;
  Window = (0, _DesktopComponent2['default'])(_DesktopComponent.WindowState)(Window) || Window;
  return Window;
})(_react.Component);

exports['default'] = Window;
module.exports = exports['default'];